'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by zhulingxiao on 2017/10/18.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @方法 fetchData
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @方法 setScrollTop
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @数据 data = {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *  isFetch, //如果正在请求, 设置isFetch = true, 防止多次请求
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *  haveMore //当返回的数据 小于 pagesize， 设置 haveMore = true
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var styles = {
    footer: {
        textAlign: 'center',
        marginTop: 20
    },
    bottomWord: {
        fontSize: 14,
        marginTop: 5,
        color: '#999'
    }
};

var DropToLoad = function (_React$PureComponent) {
    _inherits(DropToLoad, _React$PureComponent);

    function DropToLoad() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, DropToLoad);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DropToLoad.__proto__ || Object.getPrototypeOf(DropToLoad)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            isFetch: false,
            haveMore: true
        }, _this.loadingMore = function () {

            //解决scrollTop兼容性
            var scrollTop = document.body.scrollTop + document.documentElement.scrollTop;

            var _this$props$data = _this.props.data,
                isFetch = _this$props$data.isFetch,
                haveMore = _this$props$data.haveMore;

            //设置当前滚动位置

            if (_this.props.setScrollTop) {
                _this.props.setScrollTop(scrollTop);
            }

            //如果没有在请求，并且还为加载完所有数据，就能执行请求。
            if (!isFetch && haveMore) {

                var distance = document.body.scrollHeight - scrollTop;

                var triggerDistance = _this.props.triggerDistance || 20;

                if (distance < document.documentElement.clientHeight + triggerDistance) {

                    _this.props.fetchData();
                }
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(DropToLoad, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('scroll', this.loadingMore);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('scroll', this.loadingMore);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                children = _props.children,
                data = _props.data,
                color = _props.color,
                bottomWord = _props.bottomWord,
                loadingEle = _props.loadingEle;
            var haveMore = data.haveMore;


            return _react2.default.createElement(
                'div',
                null,
                children,
                _react2.default.createElement(
                    'div',
                    { key: 'icon', style: styles.footer },
                    haveMore ? loadingEle ? loadingEle : 'loading...' : _react2.default.createElement(
                        'span',
                        { style: styles.bottomWord },
                        bottomWord || '没有更多了...'
                    )
                )
            );
        }
    }]);

    return DropToLoad;
}(_react2.default.PureComponent);

DropToLoad.propTypes = {
    triggerDistance: _propTypes2.default.number,
    bottomWord: _propTypes2.default.string,
    setScrollTop: _propTypes2.default.func,
    fetchData: _propTypes2.default.func.isRequired,
    data: _propTypes2.default.object.isRequired,
    loadingEle: _propTypes2.default.element
};

exports.default = DropToLoad;